package net.minecraft.server.management;

import java.lang.reflect.Method;
import net.minecraft.server.management.PlayerManager.PlayerInstance;
import net.minecraft.network.Packet;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import codechicken.lib.asm.ObfMapping;

public class CCPlayerManagerEx {

    static Method getOrCreateChunkWatcher = ObfMapping.getMethod(PlayerManager.class,
        "getOrCreateChunkWatcher", "func_72690_a", "(IIZ)Lnet/minecraft/server/management/PlayerManager$PlayerInstance;",
        int.class, int.class, boolean.class);
    
    public static void sendPacketToChunk(Packet packet, World world, int chunkX, int chunkZ)
    {
        Object p;
        try {
            p = getOrCreateChunkWatcher.invoke(((WorldServer)world).getPlayerManager(), chunkX, chunkZ, false);
        }
        catch (Exception e) {
            throw new RuntimeException(e);
        }
        if(p != null)
            ((PlayerInstance)p).sendToAllPlayersWatchingChunk(packet);
    }
    
}
